/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 23 oct. 2006 19:03:37

import java.lang.reflect.InvocationTargetException;

import org.cocktail.carambole.server.MyComponent;
import org.cocktail.carambole.server.controleurs.MenuCtrl;

import com.webobjects.appserver.WOActionResults;
import com.webobjects.appserver.WOContext;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSDictionary;
import com.webobjects.foundation.NSMutableDictionary;
import com.webobjects.foundation.NSSelector;
import com.webobjects.foundation._NSStringUtilities;

public class Menu extends MyComponent {
	private static final String ON_CLICK = "onClick";
	private static final String ACTION = "action";
	private static final String TITLE = "title";
	private static final String IMAGE_FILENAME = "imageFilename";

	private static final long serialVersionUID = 1L;

	public static final String MENU_CONTAINER_ID = "Menu";

	public static final String ANNULER_UN_REVERSEMENT_KEY = "AnnulerUnReversement";
	public static final String ENREGISTRER_UN_REVERSEMENT_KEY = "EnregistrerUnReversement";
	public static final String ANNULER_UNE_REIMPUTATION_KEY = "AnnulerUneReimputation";
	public static final String ENREGISTRER_UNE_REIMPUTATION_KEY = "EnregistrerUneReimputation";
	public static final String ANNULER_UNE_LIQUIDATION_KEY = "AnnulerUneLiquidation";
	public static final String ENREGISTRER_UNE_LIQUIDATION_KEY = "EnregistrerUneLiquidation";
	public static final String ENREGISTRER_UNE_LIQUIDATION_SANS_ENGAGEMENT_KEY = "EnregistrerUneLiquidationSansEngagement";
	public static final String ENREGISTRER_UNE_LIQUIDATION_SUR_EXTOURNE_ENVELOPPE_KEY = "EnregistrerUneLiquidationSurExtourneEnveloppe";
	public static final String ENREGISTRER_UNE_LIQUIDATION_SUR_EXTOURNE_MANDAT_KEY = "EnregistrerUneLiquidationSurExtourneMandat";
	public static final String RECHERCHER_DES_ARTICLES_KEY = "RechercherDesArticles";
	public static final String CREER_UN_NOUVEL_ARTICLE_KEY = "CreerUnNouvelArticle";
	public static final String AJOUTER_DES_SOURCES_KEY = "AjouterDesSources";
	public static final String ANNULER_UNE_COMMANDE_KEY = "AnnulerUneCommande";
	public static final String ENREGISTRER_UNE_COMMANDE_KEY = "EnregistrerUneCommande";
	public static final String RETOURNER_A_LA_LISTE_DES_FACTURES_KEY = "RetournerALaListeDesFactures";
	public static final String ENGAGEMENT_KEY = "Engagement";
	public static final String SUPPRIMER_UN_ENGAGEMENT_KEY = "SupprimerUnEngagement";
	public static final String DETAILLER_UNE_COMMANDE_KEY = "DetaillerUneCommande";
	public static final String REVERSER_UNE_FACTURE_KEY = "ReverserUneFacture";
	public static final String SUPPRIMER_UNE_FACTURE_KEY = "SupprimerUneFacture";
	public static final String AFFICHER_COMMANDE_DETAILLEE_KEY = "AfficherCommandeDetaillee";
	public static final String RETOUR_A_LA_FACTURE_KEY = "RetourALaFacture";
	public static final String IMPRIMER_UNE_COMMANDE_KEY = "ImprimerUneCommande";
	public static final String INFORMER_KEY = "Informer";
	public static final String SUPPRIMER_UNE_COMMANDE_KEY = "SupprimerUneCommande";
	public static final String SOLDER_UNE_COMMANDE_KEY = "SolderUneCommande";
	public static final String LIQUIDER_UNE_COMMANDE_KEY = "LiquiderUneCommande";
	public static final String DUPLIQUER_UNE_COMMANDE_KEY = "DupliquerUneCommande";
	public static final String MODIFIER_UNE_COMMANDE_KEY = "ModifierUneCommande";
	public static final String ACTUALISER_LES_PRE_LIQUIDATIONS_KEY = "ActualiserLesPreLiquidations";
	public static final String ACTUALISER_LES_PRE_COMMANDES_KEY = "ActualiserLesPreCommandes";
	public static final String BASCULER_EN_MASSE_KEY = "BasculerEnMasse";
	public static final String DUPLIQUER_EN_MASSE_KEY = "DupliquerEnMasse";
	public static final String SOLDER_EN_MASSE_KEY = "SolderEnMasse";
	public static final String MODIFIER_LA_RECHERCHE_KEY = "ModifierLaRecherche";
	public static final String RETOUR_A_LA_LISTE_KEY = "RetourALaListe";
	public static final String QUITTER_KEY = "Quitter";
	public static final String ACCUEIL_KEY = "Accueil";
	public static final String B2B_MODIFIER_LES_ARTICLES_KEY = "B2bModifierLesArticles";
	public static final String B2B_ENVOYER_UNE_COMMANDE_KEY = "B2bEnvoyerUneCommande";
	public static final String LIQUIDER_SUR_EXTOURNE_MANDAT = "LiquiderSurExtourneMandat";
	public static final String SOLDER_EXTOURNE_MANDAT = "SolderExtourneMandat";

	public MenuCtrl controleur = null;
	private static NSMutableDictionary<String, NSDictionary<String, String>> itemsMenu = null;
	private NSArray<NSDictionary<String, String>> lesItemsMenuAAfficher = null;
	private NSDictionary<String, String> unItemMenu;
	public String rechercheRapide = "";

	public Menu(WOContext context) {
		super(context);
		controleur = new MenuCtrl(this);
	}

	private NSMutableDictionary<String, NSDictionary<String, String>> itemsMenu() {
		if (itemsMenu == null) {
			NSMutableDictionary<String, String> unItem;

			itemsMenu = new NSMutableDictionary<String, NSDictionary<String, String>>();

			// Items communs a plusieurs pages

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("accueil", ACTION);
			unItem.setObjectForKey("Accueil", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, ACCUEIL_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("quitter", ACTION);
			unItem.setObjectForKey("Quitter", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment quitter cette application ?');", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, QUITTER_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("retourALaListe", ACTION);
			unItem.setObjectForKey("Retour à la liste", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, RETOUR_A_LA_LISTE_KEY);

			// Items menu ListeDesCommandes

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("modifierLaRecherche", ACTION);
			unItem.setObjectForKey("Modifier", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, MODIFIER_LA_RECHERCHE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("solderEnMasse", ACTION);
			unItem.setObjectForKey("Solder", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment solder toutes les commandes selectionnees ?');", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, SOLDER_EN_MASSE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("dupliquerEnMasse", ACTION);
			unItem.setObjectForKey("Dupliquer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment dupliquer toutes les commandes selectionnees ?');", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, DUPLIQUER_EN_MASSE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("basculerEnMasse", ACTION);
			unItem.setObjectForKey("Basculer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment basculer toutes les commandes selectionnees ?');", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, BASCULER_EN_MASSE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("actualiserLesPreCommandes", ACTION);
			unItem.setObjectForKey("Actualiser", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, ACTUALISER_LES_PRE_COMMANDES_KEY);

			// Items menu PreLiquidationListe

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("actualiserLesPreLiquidations", ACTION);
			unItem.setObjectForKey("Actualiser", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, ACTUALISER_LES_PRE_LIQUIDATIONS_KEY);

			// Items menu DetailDUneCommande

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("modifierUneCommande", ACTION);
			unItem.setObjectForKey("Modifier", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, MODIFIER_UNE_COMMANDE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("dupliquerUneCommande", ACTION);
			unItem.setObjectForKey("Dupliquer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, DUPLIQUER_UNE_COMMANDE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("liquiderUneCommande", ACTION);
			if (!mySession().isServiceFacturierDisponible()) {
				unItem.setObjectForKey("Liquider", TITLE);
			}
			else {
				unItem.setObjectForKey("Pré-Liquider", TITLE);
			}
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, LIQUIDER_UNE_COMMANDE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("solderUneCommande", ACTION);
			unItem.setObjectForKey("Solder", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment solder cette commande ?');", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, SOLDER_UNE_COMMANDE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("supprimerUneCommande", ACTION);
			unItem.setObjectForKey("Supprimer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment supprimer cette commande ?');", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, SUPPRIMER_UNE_COMMANDE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("informer", ACTION);
			unItem.setObjectForKey("Informer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("openListeSelectionWin(null,this.href,'Informer','CommandeDetaillee','Contenu',true);return false;", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, INFORMER_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("imprimerUneCommande", ACTION);
			unItem.setObjectForKey("Imprimer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, IMPRIMER_UNE_COMMANDE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("b2bEnvoyerUneCommande", ACTION);
			unItem.setObjectForKey("Envoyer (B2b)", TITLE);
			unItem.setObjectForKey("Envoyer la commande au site marchand (B2b)", "tooltip");
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("openListeSelectionWin(null,this.href,'Envoyer la commande au site marchand','CommandeDetaillee','Contenu',true);return false;", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, B2B_ENVOYER_UNE_COMMANDE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("retourALaFacture", ACTION);
			unItem.setObjectForKey("Retour à la facture", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, RETOUR_A_LA_FACTURE_KEY);

			// Items menu Detail Engagement

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("afficherCommandeDetaillee", ACTION);
			unItem.setObjectForKey("Detail Cmde", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, AFFICHER_COMMANDE_DETAILLEE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("supprimerUnEngagement", ACTION);
			unItem.setObjectForKey("Supprimer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, SUPPRIMER_UN_ENGAGEMENT_KEY);

			// Items menu Detail Facture

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("supprimerUneFacture", ACTION);
			unItem.setObjectForKey("Supprimer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, SUPPRIMER_UNE_FACTURE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("reverserUneFacture", ACTION);
			unItem.setObjectForKey("Reverser", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, REVERSER_UNE_FACTURE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("detaillerUneCommande", ACTION);
			unItem.setObjectForKey("Commande", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, DETAILLER_UNE_COMMANDE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("engagement", ACTION);
			unItem.setObjectForKey("Engagement", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, ENGAGEMENT_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("retournerALaListeDesFactures", ACTION);
			unItem.setObjectForKey("Retour à la liste", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, RETOURNER_A_LA_LISTE_DES_FACTURES_KEY);

			// Items menu BonDeCommande

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("enregistrerUneCommande", ACTION);
			unItem.setObjectForKey("Enregistrer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment enregistrer cette commande ?');", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, ENREGISTRER_UNE_COMMANDE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("annulerUneCommande", ACTION);
			unItem.setObjectForKey("Annuler", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment annuler les \\nderni&#232res modifications de cette commande ?');", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, ANNULER_UNE_COMMANDE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("ajouterDesSources", ACTION);
			unItem.setObjectForKey("openListeSelectionWin(null,this.href,'Ajouter des sources de financement','Sources','Contenu',true);return false;", ON_CLICK);
			unItem.setObjectForKey("Ajout de credits", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, AJOUTER_DES_SOURCES_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("creerUnNouvelArticle", ACTION);
			unItem.setObjectForKey("openListeSelectionWin(null,this.href,'Creer un nouvel article','Articles','Contenu',true);return false;", ON_CLICK);
			unItem.setObjectForKey("Nouvel article", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, CREER_UN_NOUVEL_ARTICLE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("b2bModifierLesArticles", ACTION);
			unItem.setObjectForKey("Modifier le panier (b2b)", TITLE);
			unItem.setObjectForKey("if (openConfirmPanel('Les articles d&#233;j&#224; r&#233;cup&#233;r&#233;s du site marchand seront effac&#233;s par les nouveaux, voulez-vous vraiment modifier les articles command&#233;s ?')) {" + BonDeCommande2.modifPanierOnClick() + " } else {return false;}",
					ON_CLICK);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, B2B_MODIFIER_LES_ARTICLES_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("rechercherDesArticles", ACTION);
			unItem.setObjectForKey("Rechercher", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, RECHERCHER_DES_ARTICLES_KEY);

			// Items menu Liquidation
			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("enregistrerUneLiquidation", ACTION);
			unItem.setObjectForKey("Enregistrer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, ENREGISTRER_UNE_LIQUIDATION_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("enregistrerUneLiquidationSansEngagement", ACTION);
			unItem.setObjectForKey("Enregistrer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, ENREGISTRER_UNE_LIQUIDATION_SANS_ENGAGEMENT_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("enregistrerUneLiquidationSurExtourneEnveloppe", ACTION);
			unItem.setObjectForKey("Enregistrer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, ENREGISTRER_UNE_LIQUIDATION_SUR_EXTOURNE_ENVELOPPE_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("enregistrerUneLiquidationSurExtourneMandat", ACTION);
			unItem.setObjectForKey("Enregistrer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, ENREGISTRER_UNE_LIQUIDATION_SUR_EXTOURNE_MANDAT_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("liquiderSurExtourneMandat", ACTION);
			unItem.setObjectForKey("Liquider", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, LIQUIDER_SUR_EXTOURNE_MANDAT);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("solderExtourneMandat", ACTION);
			unItem.setObjectForKey("Solder", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment solder le mandat d\\\'extourne sélectionné, plus aucune liquidation ne pourra être créée à partir de ce madat d\\\'extourne ?');", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, SOLDER_EXTOURNE_MANDAT);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("annulerUneLiquidation", ACTION);
			unItem.setObjectForKey("Annuler", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			if (mySession().isServiceFacturierDisponible() && mySession().getLaDepensePapierEnCours() != null && mySession().getLaDepensePapierEnCours().isPreLiquidation()) {
				unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment annuler la pr&#233;-liquidation en cours ?');", ON_CLICK);
			}
			else {
				unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment annuler la liquidation en cours ?');", ON_CLICK);
			}
			itemsMenu.setObjectForKey(unItem, ANNULER_UNE_LIQUIDATION_KEY);

			// Items menu Reimputation
			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("enregistrerUneReimputation", ACTION);
			unItem.setObjectForKey("Enregistrer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			itemsMenu.setObjectForKey(unItem, ENREGISTRER_UNE_REIMPUTATION_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("annulerUneReimputation", ACTION);
			unItem.setObjectForKey("Annuler", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment annuler la r&#233;imputation en cours ?');", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, ANNULER_UNE_REIMPUTATION_KEY);

			// Items menu Reversement

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("enregistrerUnReversement", ACTION);
			unItem.setObjectForKey("Enregistrer", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment enregistrer ce reversement ?');", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, ENREGISTRER_UN_REVERSEMENT_KEY);

			unItem = new NSMutableDictionary<String, String>();
			unItem.setObjectForKey("annulerUnReversement", ACTION);
			unItem.setObjectForKey("Annuler", TITLE);
			unItem.setObjectForKey("new_hover.gif", IMAGE_FILENAME);
			unItem.setObjectForKey("return openConfirmPanel('Voulez-vous vraiment annuler le reversement en cours ?');", ON_CLICK);
			itemsMenu.setObjectForKey(unItem, ANNULER_UN_REVERSEMENT_KEY);
		}

		//Mettre à jour les items dependant du contexte
		if (mySession().isServiceFacturierDisponible() && mySession().getLaDepensePapierEnCours() != null && mySession().getLaDepensePapierEnCours().isPreLiquidation()) {
			itemsMenu.get(ANNULER_UNE_LIQUIDATION_KEY).takeValueForKey("return openConfirmPanel('Voulez-vous vraiment annuler la pr&#233;-liquidation en cours ?');", ON_CLICK);
		}
		else {
			itemsMenu.get(ANNULER_UNE_LIQUIDATION_KEY).takeValueForKey("return openConfirmPanel('Voulez-vous vraiment annuler la liquidation en cours ?');", ON_CLICK);
		}

		return itemsMenu;
	}

	public NSMutableDictionary<String, NSDictionary<String, String>> lesItemsMenu() {
		return itemsMenu();
	}

	public NSArray<NSDictionary<String, String>> getLesItemsMenuAAfficher() {
		@SuppressWarnings("unchecked")
		NSArray<String> lesItems = (NSArray<String>) valueForBinding("items");
		if (lesItems != null && lesItems.count() > 0) {
			lesItemsMenuAAfficher = itemsMenu().objectsForKeys(lesItems, new NSDictionary<String, String>("NotFoundObject", "NotFoundObject"));
		}
		else {
			lesItemsMenuAAfficher = NSArray.emptyArray();
		}
		return lesItemsMenuAAfficher;
	}

	public void setLesItemsMenuAAfficher(NSArray<NSDictionary<String, String>> lesItemsMenuAAfficher) {
		this.lesItemsMenuAAfficher = lesItemsMenuAAfficher;
	}

	public NSDictionary<String, String> getUnItemMenu() {
		return unItemMenu;
	}

	public void setUnItemMenu(NSDictionary<String, String> unItemMenu) {
		this.unItemMenu = unItemMenu;
	}

	public WOActionResults actionForItemMenu() {
		String action = (String) getUnItemMenu().objectForKey(ACTION);

		NSSelector<WOActionResults> sel = new NSSelector<WOActionResults>(action);
		WOActionResults result = null;

		try {
			result = (WOActionResults) sel.invoke(controleur);
		} catch (IllegalAccessException e1) {
			e1.printStackTrace();
		} catch (IllegalArgumentException e2) {
			e2.printStackTrace();
		} catch (NoSuchMethodException e3) {
			e3.printStackTrace();
		} catch (InvocationTargetException e4) {
			e4.printStackTrace();
		}
		return result;
	}

	public String tooltipForItemMenu() {
		return ((String) getUnItemMenu().objectForKey("tooltip") == null ? "" : (String) getUnItemMenu().objectForKey("tooltip"));
	}

	public String imageFilenameForItemMenu() {
		String imageFilenameForItemMenu = (String) getUnItemMenu().objectForKey(IMAGE_FILENAME);
		if (imageFilenameForItemMenu == null || imageFilenameForItemMenu.equals("")) {
			imageFilenameForItemMenu = "new_hover.gif";
		}
		return imageFilenameForItemMenu;
	}

	public String imageFrameworkForItemMenu() {
		String imageFrameworkForItemMenu = (String) getUnItemMenu().objectForKey("imageFramework");
		if (imageFrameworkForItemMenu == null || imageFrameworkForItemMenu.equals("")) {
			imageFrameworkForItemMenu = "app";
		}

		return imageFrameworkForItemMenu;
	}

	public boolean disabledForItemMenu() {
		String action = (String) getUnItemMenu().objectForKey(ACTION);
		action = _NSStringUtilities.capitalizedString(action);
		action = "is" + action + "Disabled";
		NSSelector<Boolean> sel = new NSSelector<Boolean>(action);
		Boolean result = Boolean.FALSE;

		try {
			result = (Boolean) sel.invoke(controleur);
		} catch (IllegalAccessException e1) {
			e1.printStackTrace();
		} catch (IllegalArgumentException e2) {
			e2.printStackTrace();
		} catch (NoSuchMethodException e3) {
		} catch (InvocationTargetException e4) {
			e4.printStackTrace();
		}
		return result.booleanValue();
	}

	public String onclick() {
		String onclick = (String) getUnItemMenu().objectForKey(ON_CLICK);

		if (onclick == null) {
			onclick = "";
		}
		return onclick;
	}

	public String liClass() {
		String liClass = "";
		if (isItemMenuRechercher()) {
			liClass += "recherche";
		}
		NSArray<NSDictionary<String, String>> items = getLesItemsMenuAAfficher();
		if (items != null && items.count() > 0) {
			NSDictionary<String, String> lastItem = items.lastObject();
			NSDictionary<String, String> currentItem = getUnItemMenu();
			if (lastItem.equals(currentItem) ||
					((String) currentItem.objectForKey(TITLE)).startsWith("Retour") ||
					((String) currentItem.objectForKey(TITLE)).startsWith("Accueil")) {
				liClass += " last";
			}
		}
		return liClass;
	}

	// Methodes associees a l'item de recherche

	public boolean isItemMenuRechercher() {
		boolean isItemMenuRechercher = false;
		String action = (String) getUnItemMenu().objectForKey(ACTION);
		if (action.startsWith("recherche")) {
			isItemMenuRechercher = true;
		}

		return isItemMenuRechercher;
	}

	// Accessors du champ de recherche directe situe dans le menu
	public String getRechercheRapide() {
		return rechercheRapide;
	}

	public void setRechercheRapide(String rechercheRapide) {
		this.rechercheRapide = rechercheRapide;
	}

	// Recherche d'articles

	public boolean isRechercheArticles() {
		boolean isRechercheArticles = false;
		String action = (String) getUnItemMenu().objectForKey(ACTION);
		if (action.endsWith("Articles")) {
			isRechercheArticles = true;
		}

		return isRechercheArticles;
	}

	public String onFormRechercheSubmit() {
		//this.href : url de l'action du bouton (openWinSelection)
		String res = "var tfRecherche=document.getElementById('TFRecherche');";
		res += "if (tfRecherche.value.length<3) {alert('Vous devez saisir au moins 3 caracteres.');return false;};";
		res += "Element.show('busy1');";
		//res += "setTimeout('openListeSelectionWin(null,document.getElementById(\'FormRechercheArticles\').action,\'Ajouter des articles\',\'Articles\',\'Contenu\',true);',500);";
		res += "openListeSelectionWin(null,document.getElementById('FormRechercheArticles').action,'Ajouter des articles','Articles','Contenu',true);";
		res += "return false;";
		return res;

	}

}